Framework MaxGUI.Drivers
Import BRL.EventQueue
Import BRL.Retro

Include "Source\Class\TMainWindow.bmx"
Include "Source\Class\TCharTab.bmx"
Include "Source\Class\TChar.bmx"
Include "Source\Class\TItemsTab.bmx"
Include "Source\Class\TItem.bmx"

Include "Source\Class\TRepTab.bmx"
Include "Source\Class\TReputation.bmx"

Include "Source\Class\TCrypt.bmx"

Include "Source\Class\TScanner.bmx"

Include "Source\Function\GetStringBetween.bmx"

TMainWindow.Create()
TItemsTab.Create()
TCharTab.Create()
TRepTab.Create()
TItem.LoadAll( "Inventory.ini", TItem.Inventory )
TItem.LoadAll( "Backpack.ini", TItem.BackPack )

TChar.Load()
TReputation.LoadAll()

'Print TCrypt.Crypt( TChar.Name + TChar.Name + TChar.Name )

'End
Repeat
	WaitEvent()
	TMainWindow.Update()
	TItemsTab.Update()
	TCharTab.Update()
	TRepTab.Update()
Forever