Const TAB_CHAR:Int 	= 0
Const TAB_ITEMS:Int 	= 1
Const TAB_REP:Int	= 2

Type TMainWindow
	
	Global Parent:TGadget
	Global Child:TGadget[10]
	Global CurTab:Int
	
	Function Create()
		
		Local WT:String = "ItemCreation"
		Local WW:Int = 400
		Local WH:Int = 400
		Local WF:Int = WINDOW_TITLEBAR | WINDOW_CLIENTCOORDS | WINDOW_CENTER
		
		Parent = CreateWindow( WT, 0, 0, WW, WH, Null, WF )
		
		Child[0] = CreateTabber( 0, 0, WW, WH - 35, Parent )
		AddGadgetItem( Child[0], "Char" )
		AddGadgetItem( Child[0], "Items" )
		AddGadgetItem( Child[0], "Reputation" )
		
		Child[1] = CreateButton( "Exit", WW - 105, WH - 30, 100, 25, Parent )
		Child[2] = CreateButton( "Save", 5, WH - 30, 100, 25, Parent )
		Child[3] = CreateButton( "Compile", 110, WH - 30, 100, 25, Parent )
		
	End Function
	
	Function Update()
		Select EventID()
			Case EVENT_WINDOWCLOSE
				End
				
			Case EVENT_GADGETACTIOn
				Select EventSource()
					Case Child[0]
						CurTab = EventData()
						Select EventData()
							Case TAB_CHAR
								TCharTab.Show()
								TItemsTab.Hide()
								TRepTab.Hide()
							Case TAB_ITEMS
								TItemsTab.Show()
								TCharTab.Hide()
								TRepTab.Hide()
							Case TAB_REP
								TRepTab.Show()
								TItemsTab.Hide()
								TCharTab.Hide()
							Default
								CurTab = TAB_CHAR
						End Select
					
					Case Child[1]
						End
						
					Case Child[2]
						TItem.SaveAll( "Inventory.ini", TItem.Inventory )
						TItem.SaveAll( "BackPack.ini", TItem.BackPack )
						TChar.Save()
						TReputation.SaveAll()
						
					Case Child[3]
						TScanner.Compile( "Compile.ini" )
						
				End Select
		End Select
	End Function
	
End Type