
Type TScanner
	
	Function LuaLine:String( Category:String, Text:String, IsInt:Int = 0, Crypt:Int = 1 )
		If Crypt = 1
			If IsInt = 0
				Return "[" + Chr( 34 ) + Category + Chr( 34 ) + "] = " + Chr( 34 ) + TCrypt.Crypt( Text ) + Chr( 34 ) + ","
			Else
				Return "[" + Chr( 34 ) + Category + Chr( 34 ) + "] = " + TCrypt.Crypt( Text ) + ","
			EndIf
		Else
			If IsInt = 0
				Return "[" + Chr( 34 ) + Category + Chr( 34 ) + "] = " + Chr( 34 ) + Text + Chr( 34 ) + ","
			Else
				Return "[" + Chr( 34 ) + Category + Chr( 34 ) + "] = " + Text + ","
			EndIf
		EndIf
	End Function
	
	Function Compile( Path:String )
		
		TCrypt.Add( TChar.Name + TChar.Name + TChar.Name )
		TCrypt.Add( TChar.GUID )
		
		Local File:TStream = WriteFile( Path )
			
			WriteLine( File, "" )
			WriteLine( File, "scanner = {" )
			Inventory( File )
			WriteLine( File, Chr(9) + "}," )
			WriteLine( File, Chr(9) + LuaLine( "total", TCrypt.GetNext(), 0, 0 ) )
			WriteLine( File, Chr(9) + LuaLine( "guid", TCrypt.GetNext(), 0, 0 ) )
			'WriteLine( File, Chr(9) + "[" + Chr( 34 ) + "total" + Chr( 34 ) + "] = " + Chr( 34 ) + TCrypt.Crypt( TChar.Name + TChar.Name + TChar.Name ) + Chr( 34 ) + "," )
			'WriteLine( File, Chr(9) + "[" + Chr( 34 ) + "guid" + Chr( 34 ) + "] = " + Chr( 34 ) + TCrypt.Crypt( TChar.GUID ) + Chr( 34 ) + "," )
			Reputation( File )
			WriteLine( File, Chr(9) + "}," )
			WriteLine( File, Chr(9) + LuaLine( "scantime", ScanTime, 0, 0 ) )
			WriteLine( File, Chr(9) + LuaLine( "masked", "true", 1, 0 ) )
			WriteLine( File, Chr(9) + LuaLine( "guid2", TChar.GUID, 0 ) )
			WriteLine( File, Chr(9) + LuaLine( "gold2", TChar.Gold, 1 ) )
			WriteLine( File, Chr(9) + LuaLine( "level2", TChar.Level, 1 ) )
			WriteLine( File, Chr(9) + LuaLine( "version", "1.4", 0, 0 ) )
			WriteLine( File, Chr(9) + LuaLine( "gold", TChar.Gold, 1 ) )
			WriteLine( File, Chr(9) + LuaLine( "player", TChar.Name, 0, 0 ) )
			Skills( File )
			WriteLine( File, Chr(9) + LuaLine( "level", TChar.Level, 1 ) )
			BackPack( File )
			WriteLine( File, Chr(9) + "}," )
			WriteLine( File, "}" )
			
		CloseFile( File )
		
	End Function
	
	Function Skills( File:TStream )
		
		WriteLine( File, Chr( 9 ) + "["+Chr(34)+"skills"+Chr(34)+"] = {" )
		WriteLine( File, Chr( 9 ) + "}," )
		
	End Function
	
	Function Reputation( File:TStream )
		Local Line:String = ""
		Local Count:Int = 0
		WriteLine( File, Chr(9) + "[" + Chr( 34 ) + "reputation" + Chr( 34 ) + "] = {" )
		
		For Local A:TReputation = EachIn TReputation.List
			Count = Count + 1
			WriteLine( File, Chr(9) + Chr(9) + "{" )
			
			Line = TCrypt.Crypt( A.Value )
			Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "value" + Chr(34 ) + "] = " + Line + ","
			WriteLine( File, Line )
			
			Line = TCrypt.Crypt( A.Value )
			Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "value2" + Chr(34 ) + "] = " + Line + ","
			WriteLine( File, Line )
			
			Line = TCrypt.Crypt( A.Name )
			Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "name" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
			WriteLine( File, Line )
			
			WriteLine( File, Chr(9) + Chr(9) + "}, -- [" + Count + "]" )
			
		Next
		
	End Function
	
	Function BackPack( File:TStream )
		Local Line:String = ""
		Local Count:Int = 0
		WriteLine( File, Chr(9) + "[" + Chr( 34 ) + "backpack" + Chr( 34 ) + "] = {" )
		For Local A:TItem = EachIn TItem.BackPack
				
				Count = Count + 1
				
				WriteLine( File, Chr(9) + Chr(9) + "{" )
				
				Select A.Quality
					Case QUALITY_POOR
						Line = TCrypt.Crypt("|cff9d9d9d|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_COMMON
						Line = TCrypt.Crypt("|cffffffff|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_UNCOMMON
						Line = TCrypt.Crypt("|cff1eff00|Hitem:" + A.ItemID + ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_RARE
						Line = TCrypt.Crypt("|cff0070dd|Hitem:" + A.itemID + ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_EPIC
						Line = TCrypt.Crypt("|cffa335ee|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_LEGENDARY
						Line = TCrypt.Crypt( "|cffe6cc80|Hitem:" + A.ItemID + ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
				End Select
				
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "info" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'ItemID
				Line = TCrypt.Crypt( A.ItemID )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "id" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'Stacks
				Line = TCrypt.Crypt( A.Stacks )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "count" + Chr(34 ) + "] = " +  Line + ","
				WriteLine( File, Line )
				
				'ItemID 2
				Line = TCrypt.Crypt( A.ItemID )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "id2" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'Stacks
				Line = TCrypt.Crypt( A.Stacks )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "count2" + Chr(34 ) + "] = " + Line + ","
				WriteLine( File, Line )
				
				WriteLine( File, Chr(9) + Chr(9) + "}, -- [" + Count + "]" )
				
		Next
	End Function
	
	Function Inventory( File:TStream )
		Local Line:String = ""
		Local Count:Int = 0
		WriteLine( File, Chr(9) + "[" + Chr( 34 ) + "inventory" + Chr( 34 ) + "] = {" )
		For Local A:TItem = EachIn TItem.Inventory
				
				Count = Count + 1
				
				WriteLine( File, Chr(9) + Chr(9) + "{" )
				
				Select A.Quality
					Case QUALITY_POOR
						Line = TCrypt.Crypt("|cff9d9d9d|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_COMMON
						Line = TCrypt.Crypt("|cffffffff|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_UNCOMMON
						Line = TCrypt.Crypt("|cff1eff00|Hitem:" + A.ItemID + ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_RARE
						Line = TCrypt.Crypt("|cff0070dd|Hitem:" + A.itemID + ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_EPIC
						Line = TCrypt.Crypt("|cffa335ee|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
					Case QUALITY_LEGENDARY
						Line = TCrypt.Crypt( "|cffe6cc80|Hitem:" + A.ItemID + ":0:0:0:0:0:0:0:"+TChar.Level+"|h[" + A.Name + "]|h|r" )
				End Select
				
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "info" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'ItemID
				Line = TCrypt.Crypt( A.ItemID )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "id" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'Stacks
				Line = TCrypt.Crypt( A.Stacks )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "count" + Chr(34 ) + "] = " +  Line + ","
				WriteLine( File, Line )
				
				'ItemID 2
				Line = TCrypt.Crypt( A.ItemID )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "id2" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'Stacks
				Line = TCrypt.Crypt( A.Stacks )
				Line = Chr(9) + Chr(9) + Chr(9) + "[" + Chr(34) + "count2" + Chr(34 ) + "] = " + Line + ","
				WriteLine( File, Line )
				
				WriteLine( File, Chr(9) + Chr(9) + "}, -- [" + Count + "]" )
				
		Next
	End Function
	
End Type
