
Type TCharTab
	
	Global Parent:TGadget
	Global Child:TGadget[10]
	Global Font:TGuiFont = LoadGuiFont( "Ariel", 12, True, False, False, False )
	
	Function Create()
		
		Parent = TMainWindow.Child[0]
		Local WW:Int = ClientWidth( Parent )
		Local WH:Int = ClientHeight( Parent )
		
		Child[0] = CreateLabel( "", 5, 5, WW - 10, 25, Parent, LABEL_CENTER )
		SetGadgetColor( Child[0], 0, 0, 0 )
		SetGadgetColor( Child[0], 255, 255, 255, False )
		SetGadgetFont( Child[0], Font )
		
		Child[1] = CreateTextField( 5, 35, 200, 25, Parent )
		Child[2] = CreateLabel( "Name", 210, 40, WW - 200, 25, Parent )
		Child[3] = CreateTextField( 5, 65, 200, 25, Parent )
		Child[4] = CreateLabel( "GUID", 210, 70, WW - 200, 25, Parent )
		Child[5] = CreateTextField( 5, 95, 50, 25, Parent )
		Child[6] = CreateLabel( "Level", 60, 100, WW - 200, 25, Parent )
		Child[7] = CreateTextField( 5, 125, 50, 25, Parent )
		Child[8] = CreateLabel( "Gold (In Copper)", 60, 130, WW - 200, 25, Parent )
		
	End Function
	
	Function Update()
		
		Select EventID()
			
			Case EVENT_GADGETACTION
				Select EventSource()
					
					Case Child[1]
						UpdateLabel()
						TChar.Name = GadgetText( Child[1] )
					
					Case Child[3]
						TChar.GUID = GadgetText( Child[3] )
					
					Case Child[5]
						UpdateLabel()
						TChar.Level = Int( GadgetText( Child[5] ) )
						
					Case Child[7]
						TChar.Gold = Int( GadgetText( Child[7] ) )
						
				End Select
			
		End Select
		
	End Function
	
	Function Hide()
		For Local X:Int = 0 To 8
			HideGadget( Child[X] )
			DisableGadget( Child[X] )
		Next
	End Function
	
	Function Show()
		For Local X:Int = 0 To 8
			ShowGadget( Child[X] )
			EnableGadget( Child[X] )
		Next
	End Function
	
	Function UpdateLabel()
		SetGadgetText( Child[0], GadgetText( Child[1] ) + ", Level " + GadgetText( Child[5] ) )
	End Function
	
	Function UpdateForm()
		SetGadgetText( Child[1], TChar.Name )
		SetGadgetText( Child[3], TChar.GUID )
		SetGadgetText( Child[5], TChar.Level )
		SetGadgetText( Child[7], TChar.Gold )
		UpdateLabel()
	End Function
	
End Type
