
Type TReputation
	
	Global List:TList = CreateList()
	
	Field Name:String, Value:Int
	
	Function Create:TReputation( N:String, V:Int )
		
		Local A:TReputation = New TReputation
			A.Name = N
			A.Value = V
			TReputation.List.Addlast( A )
			Return( A )
		
	End Function
	
	Function LoadAll()
		
		If FileType( "Rep.ini" ) = FILETYPE_FILE
			Local File:TStream = ReadFile( "Rep.ini" )
				
				While Not Eof( File )
					
					Local N:String = ReadLine( File )
					Local V:Int = Int(ReadLine( File ))
					
					TReputation.Create( N, V )
					
					ReadLine( File )
				Wend
				
			CloseFile( File )
		EndIf
		
		TRepTab.UpdateList()
	End Function
	
	Function SaveAll()
		
		Local File:TStream = WriteFile( "Rep.ini" )
			
			For Local A:TReputation = EachIn TReputation.List
				
				WriteLine( File, A.Name )
				WriteLine( File, A.Value )
				WriteLine( File, "" )
				
			Next
			
		CloseFile( File )
		
	End Function
	
End Type
